SystemOrganization addCategory: #NOCompletion!
SystemOrganization addCategory: #'NOCompletion-Model'!
SystemOrganization addCategory: #'NOCompletion-Pharo'!
SystemOrganization addCategory: #'NOCompletion-View'!

NECSelectorEntry subclass: #NOCDatedEntry
	instanceVariableNames: 'date next previous'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NOCompletion-Model'!

!NOCDatedEntry methodsFor: 'as yet unclassified' stamp: 'rr 2/21/2009 11:49'!
<= anEntry
	^ date = anEntry date 
		ifTrue: [contents <= anEntry contents]
		ifFalse: [date > anEntry date]! !

!NOCDatedEntry methodsFor: 'as yet unclassified' stamp: 'rr 2/21/2009 11:49'!
date
	^ date! !

!NOCDatedEntry methodsFor: 'as yet unclassified' stamp: 'rr 4/9/2009 15:38'!
date: d
	date := d! !

!NOCDatedEntry methodsFor: 'as yet unclassified' stamp: 'ul 9/27/2010 05:12'!
link: anODatedEntry
	"Link the given entry after me."

	anODatedEntry
		next: next;
		previous: self.
	next previous: anODatedEntry.
	next := anODatedEntry! !

!NOCDatedEntry methodsFor: 'as yet unclassified' stamp: 'ul 9/27/2010 05:38'!
matches: pref

	^contents beginsWithEmpty: pref caseSensitive: false! !

!NOCDatedEntry methodsFor: 'as yet unclassified' stamp: 'ul 9/27/2010 05:07'!
next

	^next! !

!NOCDatedEntry methodsFor: 'as yet unclassified' stamp: 'ul 9/27/2010 05:08'!
next: anODatedEntry

	next := anODatedEntry! !

!NOCDatedEntry methodsFor: 'as yet unclassified' stamp: 'rr 4/9/2009 15:32'!
now
	date := DateAndTime now! !

!NOCDatedEntry methodsFor: 'as yet unclassified' stamp: 'ul 9/27/2010 05:07'!
previous

	^previous! !

!NOCDatedEntry methodsFor: 'as yet unclassified' stamp: 'ul 9/27/2010 05:08'!
previous: anODatedEntry

	previous := anODatedEntry! !

!NOCDatedEntry methodsFor: 'as yet unclassified' stamp: 'ul 9/27/2010 05:08'!
unlink

	next previous: previous.
	previous next: next! !

NECMenuMorph subclass: #NOCMenuMorph
	instanceVariableNames: 'lastActivity'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NOCompletion-View'!

!NOCMenuMorph class methodsFor: 'as yet unclassified' stamp: 'EstebanLorenzano 4/12/2012 13:37'!
backgroundColor
	^NECPreferences backgroundColor alpha: 0.8! !

!NOCMenuMorph class methodsFor: 'as yet unclassified' stamp: 'EstebanLorenzano 4/11/2012 16:57'!
itemWidth

	^UITheme current listFont widthOfString:'SphinxOfBlackQuartzHearMyVow' "212."! !

!NOCMenuMorph class methodsFor: 'as yet unclassified' stamp: 'ul 10/27/2010 03:10'!
scrollColor

	^super scrollColor alpha: 0.8! !

!NOCMenuMorph class methodsFor: 'as yet unclassified' stamp: 'EstebanLorenzano 4/11/2012 16:56'!
selectFontFor: aSymbol 
	| emphasized attributes |
	attributes := SHTextStylerST80 new
				attributesFor: (self convertToSHSymbol: aSymbol).
	emphasized := attributes size > 1
				ifTrue: [attributes second emphasisCode]
				ifFalse: [0]. 
	^UITheme current menuFont 
		emphasized: emphasized! !

!NOCMenuMorph methodsFor: 'as yet unclassified' stamp: 'rr 4/15/2009 15:23'!
context
	^ context! !

!NOCMenuMorph methodsFor: 'as yet unclassified' stamp: 'rr 4/15/2009 15:24'!
context: ctx
	context := ctx.! !

!NOCMenuMorph methodsFor: 'as yet unclassified' stamp: 'rr 12/11/2007 09:41'!
createTitle! !

!NOCMenuMorph methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 4/8/2010 12:15'!
drawOn: aCanvas 
	| rectangle model textColor |
	context model isEmpty ifTrue: [^self].
	
	"super drawOn: aCanvas."
	rectangle := self bounds copy.
	rectangle bottom: rectangle top + self class itemHeight.
	rectangle := rectangle left: rectangle left + 20.
	aCanvas fillRectangle: rectangle fillStyle: self fillStyle borderStyle: self borderStyle.
	model := context model.
	self extent: self extent.
	self firstVisible > 1
		ifTrue: [self drawTopScrollArrowOn: aCanvas].
	self lastVisible ~= self itemsCount
		ifTrue: [self drawBottomScrollArrowOn: aCanvas].
	model notEmpty
		ifTrue: [self firstVisible
				to: self lastVisible
				do: [:index | 
					| symbol type string | 
					symbol := model entries at: index.
					string := symbol contents.
					type := symbol type.
					textColor := self selectColor: type.
					index = self selected
						ifTrue: [| rect | 
							rect := rectangle withBottom: rectangle top + self class itemHeight.
							aCanvas fillRectangle: rect color: self class scrollColor.
							self detailPosition: rect topRight.
							textColor := Color white ].
					aCanvas
						drawString: string
						in: (rectangle insetBy: 1)
						font: (self selectFont: type)
						color: textColor.
					rectangle := self prepareRectForNextRow: rectangle]].
	self drawMessageOn: aCanvas in: rectangle! !

!NOCMenuMorph methodsFor: 'as yet unclassified' stamp: 'rr 12/11/2007 09:44'!
drawTopScrollArrowOn: aCanvas 
	! !

!NOCMenuMorph methodsFor: 'as yet unclassified' stamp: 'rr 12/11/2007 09:39'!
hasMessage
	^ false! !

!NOCMenuMorph methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/2/2010 17:55'!
height
	^ 4! !

!NOCMenuMorph methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 4/8/2010 12:19'!
initialize 
	super initialize.
	self on: #mouseDown send: #delete to: self.
	self startStepping! !

!NOCMenuMorph methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 4/8/2010 12:08'!
lastActivity 
	lastActivity ifNil: [self stillActive].
	^ lastActivity ! !

!NOCMenuMorph methodsFor: 'as yet unclassified' stamp: 'rr 6/26/2009 11:09'!
narrowCompletion
	| model |
	self selected: 0.
	firstVisible := 1.
	model := context model.
	model narrowWith: context completionToken.
	"(model entries size = 1 and: [context completionToken notEmpty]) 
		ifTrue: 
			[self insertCompletion: (model completionAt: 1).
			self delete.
			^ false]."
	model notEmpty ifTrue: [self selected: 1].
	self show.
	^ true! !

!NOCMenuMorph methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 4/8/2010 17:41'!
step
	self timeOfLastActivity > self timeout
		ifTrue: [ self delete ]
		ifFalse: [self updateColor]! !

!NOCMenuMorph methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 4/8/2010 17:48'!
stepTime 
	^ 100! !

!NOCMenuMorph methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 4/8/2010 17:50'!
stillActive
	lastActivity := Time millisecondClockValue.! !

!NOCMenuMorph methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 4/8/2010 17:52'!
timeOfLastActivity
	^ (Time millisecondClockValue - self lastActivity)   ! !

!NOCMenuMorph methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 4/8/2010 17:41'!
timeout
	^ 5000! !

!NOCMenuMorph methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 4/8/2010 18:00'!
updateColor
	| remaining alpha |
	remaining := (self timeout - self timeOfLastActivity).
	remaining < 1000 
		ifTrue: [
			alpha := remaining / 1000.0.
			self color: (self color alpha: alpha).
			self borderColor: (self borderColor alpha: alpha)
			]! !

NECMenuMorph subclass: #NOCXMenuMorph
	instanceVariableNames: 'lastActivity'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NOCompletion-View'!

!NOCXMenuMorph class methodsFor: 'as yet unclassified' stamp: 'ul 10/27/2010 03:10'!
scrollColor

	^super scrollColor alpha: 0.8! !

!NOCXMenuMorph class methodsFor: 'as yet unclassified' stamp: 'EstebanLorenzano 4/11/2012 15:10'!
selectFontFor: aSymbol 
	| emphasized attributes |
	attributes := SHTextStylerST80 new
				attributesFor: (self convertToSHSymbol: aSymbol).
	emphasized := attributes size > 1
				ifTrue: [attributes second emphasisCode]
				ifFalse: [0]. 
	^UITheme current menuFont 
		emphasized: emphasized! !

!NOCXMenuMorph methodsFor: 'as yet unclassified' stamp: 'rr 4/15/2009 15:23'!
context
	^ context! !

!NOCXMenuMorph methodsFor: 'as yet unclassified' stamp: 'rr 4/15/2009 15:23'!
context: ctx
	context := ctx.! !

!NOCXMenuMorph methodsFor: 'as yet unclassified' stamp: 'rr 12/11/2007 10:15'!
delete
	super delete.
	controller retract! !

!NOCXMenuMorph methodsFor: 'as yet unclassified' stamp: 'rr 12/11/2007 09:45'!
hasMessage
	^ false! !

!NOCXMenuMorph methodsFor: 'as yet unclassified' stamp: 'rr 4/15/2009 15:32'!
height
	^ 7! !

!NOCXMenuMorph methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 4/8/2010 12:21'!
initialize 
	super initialize.
	self on: #mouseDown send: #delete to: self.
	self startStepping ! !

!NOCXMenuMorph methodsFor: 'as yet unclassified' stamp: 'rr 12/11/2007 10:14'!
insertCompletion: aString
	super insertCompletion: aString.
	controller retract! !

!NOCXMenuMorph methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 4/8/2010 12:20'!
lastActivity 
	lastActivity ifNil: [self stillActive].
	^ lastActivity ! !

!NOCXMenuMorph methodsFor: 'as yet unclassified' stamp: 'rr 6/26/2009 11:33'!
narrowCompletion
	| model |
	
	self selected: 0.
	firstVisible := 1.
	model := context model.
	model narrowWith: context completionToken.
	model notEmpty ifTrue: [self selected: 1].
	model entries size < self selected ifTrue: [self selected: model entries size].
	self show.
	^ true! !

!NOCXMenuMorph methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 4/8/2010 17:59'!
step
	self timeOfLastActivity > self timeout
		ifTrue: [ self delete ]
		ifFalse: [self updateColor]! !

!NOCXMenuMorph methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 4/8/2010 17:56'!
stepTime 
	^ 100! !

!NOCXMenuMorph methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 4/8/2010 17:55'!
stillActive
	lastActivity := Time millisecondClockValue.! !

!NOCXMenuMorph methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 4/8/2010 17:55'!
timeOfLastActivity
	^ (Time millisecondClockValue - self lastActivity)   ! !

!NOCXMenuMorph methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 4/8/2010 17:55'!
timeout
	^ 5000! !

!NOCXMenuMorph methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 4/8/2010 18:00'!
updateColor
	| remaining alpha |
	remaining := (self timeout - self timeOfLastActivity).
	
	remaining < 1000 
		ifTrue: [
			alpha := remaining / 1000.0.
			self color: (self color alpha: alpha).
			self borderColor: (self borderColor alpha: alpha)
			]! !

NECController subclass: #NOCController
	instanceVariableNames: 'expanded contextClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NOCompletion-Model'!

!NOCController class methodsFor: 'class initialization' stamp: 'EstebanLorenzano 4/12/2012 13:25'!
initialize 
	super initialize.
	self register.! !

!NOCController methodsFor: 'private' stamp: 'EstebanLorenzano 4/12/2012 11:17'!
contextClass
	^NOCContext! !

!NOCController methodsFor: 'as yet unclassified' stamp: 'EstebanLorenzano 4/12/2012 11:21'!
expand
	
	expanded := true.
	(self model isKindOf: NOCModel) ifTrue: [self model expand].! !

!NOCController methodsFor: 'as yet unclassified' stamp: 'rr 12/11/2007 09:45'!
expanded
	^ expanded ifNil: [expanded := false]! !

!NOCController methodsFor: 'keyboard' stamp: 'EstebanLorenzano 4/11/2012 16:05'!
handleKeystrokeBefore: kbEvent editor: theEditor 
	"I return a boolean. true when I have handled the event and no futher processing is needed by the caller."
	| keyValue ctrl cmd down tab colon alphanum del esc enter up |

	self setEditor: theEditor.
	self setModel: theEditor model.
	keyValue := kbEvent keyValue.
	ctrl := kbEvent controlKeyPressed.
	cmd := kbEvent commandKeyPressed.
	down := keyValue = 31.
	up := keyValue = 30.
	tab := kbEvent keyCharacter = Character tab.
	enter := kbEvent keyCharacter = Character cr.
	colon := kbEvent keyCharacter = $:.
	alphanum := kbEvent keyCharacter isAlphaNumeric.
	del := keyValue = 8.
	esc := keyValue = 27.

	self isMenuOpen ifTrue: [menuMorph stillActive].

	del	ifTrue: [ self smartBackspace ].
	self expanded ifTrue: [ ^ super handleKeystrokeBefore: kbEvent editor: theEditor ].
	
	esc ifTrue: [self isMenuOpen ifTrue: [self retract; closeMenu. ^ true]].
	
	((tab) and: [theEditor wordAtCaret notEmpty]) ifTrue: [
		(context notNil and: [context model notEmpty and: [menuMorph selected > 0]]) 
				ifTrue: [menuMorph insertSelected ifTrue: [ ^ true ] ]
				ifFalse: [enter ifFalse: [self openXMenuFor: theEditor. ^true]]].		
	
	self isMenuOpen & (colon | alphanum | up | down | tab | del) not ifTrue: [self retract; closeMenu.].
	
	
	del	ifTrue: [ theEditor isCaretBehindChar not
						ifTrue: [ self closeMenu ].
					^ false].

	(ctrl not & cmd not & alphanum) 
		ifTrue: [ 
			theEditor text ifEmpty: [^ false].  
			theEditor selection ifNotEmpty: [theEditor replaceSelectionWith: ''].
			self isMenuOpen ifFalse: [ self openMenuFor: theEditor ].
			theEditor text ifNotNil: [ menuMorph changed ]. ^false]
		ifFalse: [
			(self smartInput: keyValue) ifNotNil: [^ true]].
		
	down & self isMenuOpen ifTrue: [
			
			menuMorph selected = 3 ifTrue: [self openXMenuFor: theEditor].
			menuMorph moveDown.
			^ true ].
	
	up & self isMenuOpen ifTrue:  [
		
		menuMorph moveUp.
		^ true]. 
	
	^ super handleKeystrokeBefore: kbEvent editor: theEditor 
! !

!NOCController methodsFor: 'initialize-release' stamp: 'EstebanLorenzano 4/12/2012 11:17'!
initialize
	contextClass := NOCContext.! !

!NOCController methodsFor: 'accessing' stamp: 'EstebanLorenzano 4/12/2012 11:22'!
menuMorph
	^ self expanded ifTrue: [NOCXMenuMorph] ifFalse: [NOCMenuMorph]! !

!NOCController methodsFor: 'private' stamp: 'EstebanLorenzano 4/12/2012 11:21'!
menuMorphClass
	^ NOCMenuMorph! !

!NOCController methodsFor: 'menu morph' stamp: 'EstebanLorenzano 4/11/2012 11:42'!
openXMenuFor: anEditor 
	| theMenu |
	self closeMenu.
	context := menuMorph 
		ifNotNil: [menuMorph context] 
		ifNil: [self contextClass 
				controller: self
				class: self model selectedClassOrMetaClass
				source: anEditor text string
				position: anEditor startIndex - 1].
	
	self setEditor: anEditor.
	self expand.
	theMenu := self menuMorph controller: self
				position: (anEditor selectionPosition: context completionToken).
	theMenu isClosed ifFalse: [menuMorph := theMenu].
	menuMorph moveDown; moveDown. 
	! !

!NOCController methodsFor: 'as yet unclassified' stamp: 'EstebanLorenzano 4/12/2012 11:21'!
retract
	expanded := false.
	(self model isKindOf: NOCModel) ifTrue: [self model contract].! !

NECUntypedModel subclass: #NOCModel
	instanceVariableNames: 'table expand nextModel cachedEntries ctable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NOCompletion-Model'!

!NOCModel methodsFor: 'accessing' stamp: 'rr 5/28/2009 11:29'!
addEntry: ent
	(self tableForEntry: ent) addEntry: ent ! !

!NOCModel methodsFor: 'accessing' stamp: 'rr 4/14/2009 13:56'!
addSelectors
	! !

!NOCModel methodsFor: 'accessing' stamp: 'damiencassou 7/27/2009 14:22'!
at: aNumber
	
	^ self entries at: (aNumber max: 1) ! !

!NOCModel methodsFor: 'accessing' stamp: 'rr 5/28/2009 14:17'!
completionAt: aNumber
	| entry |
	"when an entry is selected, update its date (for inlined messages which do not appear in the method's body"
	entry := (self at: aNumber) completion.
	self addEntry: entry.
	^ entry separateKeywords, ' '.! !

!NOCModel methodsFor: 'accessing' stamp: 'rr 4/15/2009 13:28'!
contract
	expand := false.
	nextModel := nil.! !

!NOCModel methodsFor: 'accessing' stamp: 'RomainRobbes 8/2/2010 17:58'!
entries
	| ent more |
	entries ifNotEmpty: [^expand not & (entries size > 3) ifTrue: [entries first: 3] ifFalse: [entries ]].
	ent := (narrowString notEmpty and: [narrowString first isUppercase]) 
					ifTrue: [ctable entriesMatching: narrowString] 
					ifFalse: [includeSelectors 
										ifTrue: [table entriesMatching: narrowString]
										ifFalse: [ent := super entries]].
	ent := ent asOrderedCollection.
	ent size > 7 ifTrue: [ent := ent first: 7. ].
	 ent addAll: (self nextModel entries reject: [:e | ent anySatisfy: [:ea | ea contents = e contents]]).
	entries := ent.
	^ expand not & (ent size > 3) ifTrue: [ent first: 3] ifFalse: [ent]! !

!NOCModel methodsFor: 'accessing' stamp: 'RomainRobbes 8/2/2010 17:56'!
entryCount
	^ self entries size! !

!NOCModel methodsFor: 'accessing' stamp: 'rr 4/15/2009 13:28'!
expand
	expand := true.! !

!NOCModel methodsFor: 'accessing' stamp: 'EstebanLorenzano 4/12/2012 11:17'!
initialize
	super initialize.
	self contract.
	table := NOCCompletionTable default.
	ctable := NOCCompletionTable classes.! !

!NOCModel methodsFor: 'accessing' stamp: 'rr 4/14/2009 13:56'!
initializeSelectors! !

!NOCModel methodsFor: 'accessing' stamp: 'rr 4/17/2009 14:33'!
narrowWith: aString
	self narrowString: aString.
	self resetEntries.
	self addVariables.
	self nextModel ifNotNilDo: [:nm | nm narrowWith: aString].! !

!NOCModel methodsFor: 'accessing' stamp: 'EstebanLorenzano 4/12/2012 11:20'!
nextModel
	^ expand 
		ifTrue: [nextModel ifNil: [nextModel := NECUntypedModel class: clazz temporaries: localVars additionals: #() variables: includeVariables selectors: includeSelectors. nextModel narrowWith: narrowString] ifNotNil: [nextModel]]
		ifFalse: [NOCEmptyModel new]! !

!NOCModel methodsFor: 'accessing' stamp: 'EstebanLorenzano 4/12/2012 11:20'!
noNextModel
	nextModel := NOCEmptyModel new.! !

!NOCModel methodsFor: 'accessing' stamp: 'TestRunner 11/30/2009 14:07'!
resetEntries
	super resetEntries.
	"table ifNotNil: [table reset].
	ctable ifNotNil: [ctable reset]"! !

!NOCModel methodsFor: 'accessing' stamp: 'rr 4/14/2009 13:46'!
table
	^ table! !

!NOCModel methodsFor: 'accessing' stamp: 'rr 5/28/2009 14:18'!
tableForEntry: ent
	^ (ent notEmpty and: [ent first isUppercase]) 
			ifTrue: [ctable]
			ifFalse: [table]! !

!NOCModel methodsFor: 'accessing' stamp: 'EstebanLorenzano 4/12/2012 11:17'!
useUniqueTable
	table := NOCCompletionTable new entriesPerPrefix: 20.
	! !

NECContext subclass: #NOCContext
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NOCompletion-Model'!

!NOCContext methodsFor: 'model creation' stamp: 'EstebanLorenzano 4/12/2012 11:21'!
createModel
	| mdl |		
	mdl := NOCModel
		class: theClass
		temporaries: self temporaries
		additionals: controller additionals
		variables: variables
		selectors: selectors.
	controller expanded ifTrue: [mdl expand].
	^ mdl ! !

Object subclass: #LogForImplementor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NOCompletion-Model'!

!LogForImplementor commentStamp: 'StephaneDucasse 2/26/2012 22:48' prior: 0!
I added the methods that were different (mainly in class extensions) of NECcompltation. That way we can compare.

Here are the notes resulting from the comparison of the two approaches

* ecompletion override TextMorph>>keyStroke: 

* OCompletion uses the ToolSet

ECToolSet>>codeCompletionAround: aBlock textMorph: aTextMorph keyStroke: evt
	| completionAllowed editor stringHolder |
	
	editor := aTextMorph editor.
	stringHolder := editor ifNotNil: [editor model].

	completionAllowed := NECPreferences enabled and:[ NECController allowModel: stringHolder ].
	completionAllowed
		ifTrue: [(stringHolder completionController handleKeystrokeBefore: evt editor: editor)
				ifTrue: [^ self]].
	aBlock value.
	"sends to keyStroke event handler, if any"
	"Narrow the completion with any of the keys"
	completionAllowed
		ifTrue: [stringHolder completionController handleKeystrokeAfter: evt editor: editor]
		
SmalltalkEditor>>codeCompletionAround:  aBlock textMorph:  aTextMorph keyStroke: anEvent
	"I'm a editor for Smalltalk, so, ok do completion around"
	Smalltalk tools codeCompletionAround: aBlock textMorph: aTextMorph keyStroke: anEvent
	
		
TextMorph>>keyStroke: evt
	"Handle a keystroke event."
	self resetBlinkCursor. "don't blink during type-in"
	self editor 
		codeCompletionAround: [| action |
			evt keyValue = 13 ifTrue:["CR - check for special action"
				action := self crAction.
				action ifNotNil:[
					"Note: Code below assumes that this was some
					input field reacting on CR. Break the keyboard
					focus so that the receiver can be safely deleted."
					evt hand newKeyboardFocus: nil.
					^ action value]].
			self handleInteraction: [editor keystroke: evt].
			self updateFromParagraph.
			super keyStroke: evt  "sends to keyStroke event handler, if any"]
		textMorph: self 
		keyStroke: evt
		
ToolRegistry>>codeCompletionAround: aBlock textMorph: aTextMorph keyStroke: evt
	^(self hasToolNamed: #codeCompletion)
	ifTrue: [ self codeCompletion codeCompletionAround: aBlock textMorph: aTextMorph keyStroke: evt ]
	ifFalse: [ aBlock value ]
		





* how to handle extension
so far OCompletion is doing

StringHolder|Workspace>>createCompletionController
	
	^(ECPreferences useECompletionInsteadOfOCompletion
		ifFalse: [ OController ]
		ifTrue: [ ECController ])
			model: self
	
* Then we should add something to FlatMessageListBrowser and this is not nice.
	
* we shoul unify the settings
in ECompletion the ugly squeakish preferences

useECompletionInsteadOfOCompletion

	<preference: 'Use eCompletion instead of OCompletion'
		category: 'OCompletion'
		description: 'Decide if you want to use eCompletion in newly opened tools instead of OCompletion.'
		type: #Boolean>
	^useECompletionInsteadOfOCompletion ifNil: [ false ]


in OCompletion

settingsOn: aBuilder 
	<systemsettings>
	
	(aBuilder setting: #'OCompletion: Code Completion') 
		target: self; 
		parentName: #codeBrowsing;
		selector: #enabled;
		icon: UITheme current smallConfigurationIcon;
		description: 'Enable or disable code completion in browsers, debuggers and workspaces.';
		with: [
			(aBuilder setting: #caseSensitive) 
				label: 'Case Sensitive';
		 		description: 'Decide if you want OCompletion to be case sensitive or not.'.
			(aBuilder setting: #smartCharacters) 
				label: 'Smart Characters';
		 		description: 'Decide if you want OCompletion to use smart characters, e.g, to automatically close brackets.'.
			(aBuilder setting: #matchSubStrings)
				label: 'Match SubStrings';
				description: 'Decide if you want OCompletion to perform subString searches, which can be slower, rather than only front-matching selectors.'.
			(aBuilder setting: #useECompletionInsteadOfOCompletion)
				label: 'Use eCompletion instead of OCompletion';
				description: 'Decide if you want to use eCompletion in newly opened tools instead of OCompletion.' ]
	





* Open question why 
StringHolder>>completionController
	| controller | 
	controller := self triggerEvent: #getCompletionController.
	controller ifNil:[ controller := self initializeCompletionController ].
	^controller
	
Trigger an event and the initialize

StringHolder>>initializeCompletionController
	| controller |
	controller := self createCompletionController.
	self 
		when: #getCompletionController
		evaluate: (MessageSend 
				receiver: controller
				selector: #yourself).
	^ controller
	
possible answer because this is to avoid adding an instance variable? But I do not understand since it could also just return the instance.
!

Object subclass: #NOCCompletionTable
	instanceVariableNames: 'table numberofEntries'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NOCompletion-Model'!

NOCCompletionTable class
	instanceVariableNames: 'table ctable'!

NOCCompletionTable class
	instanceVariableNames: 'table ctable'!

!NOCCompletionTable class methodsFor: 'as yet unclassified' stamp: 'rr 5/28/2009 11:14'!
classes
	^ ctable ifNil: [ctable := self new entriesPerPrefix: 40]! !

!NOCCompletionTable class methodsFor: 'as yet unclassified' stamp: 'rr 4/14/2009 17:13'!
default
	^ table ifNil: [table := self new entriesPerPrefix: 40]! !

!NOCCompletionTable class methodsFor: 'as yet unclassified' stamp: 'ul 11/6/2010 05:31'!
initialize

	SystemChangeNotifier uniqueInstance
		noMoreNotificationsFor: self; "avoid double registration"
		notify: self ofSystemChangesOfItem: #method using: #methodChanged:.
	self initializeTable.! !

!NOCCompletionTable class methodsFor: 'as yet unclassified' stamp: 'rr 4/28/2009 10:18'!
initializeTable
	self initializeWithInlinedMessages.
	self initializeWithPackages.
	self initializeWithRecentChanges.! !

!NOCCompletionTable class methodsFor: 'as yet unclassified' stamp: 'rr 4/28/2009 09:54'!
initializeWithInlinedMessages
	#(ifTrue: ifFalse: whileTrue: whileFalse: ifNil: ifNotNil: to:do: at:put: next: next size atEnd class value value: do: new: new) 
		do: [:e | self default addEntry: e].! !

!NOCCompletionTable class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 4/15/2011 12:40'!
initializeWithPackages
	| pkgs |
	pkgs :=  'Kernel* Collection*'.
	pkgs ifNotNil: [
	(pkgs findTokens: ' ' ) do: [:e |  self default quickFillWithCategoriesMatching: e ]]

! !

!NOCCompletionTable class methodsFor: 'as yet unclassified' stamp: 'EstebanLorenzano 4/12/2012 11:21'!
initializeWithRecentChanges
	NOCRecentChanges new readRecentChanges fillCompletionTable.! !

!NOCCompletionTable class methodsFor: 'as yet unclassified' stamp: 'ul 11/6/2010 06:23'!
lookForOB
	(Smalltalk at: #OBTextPanel ifAbsent: [^self]) compile: 'createCompletionController
	^(ECPreferences useECompletionInsteadOfOCompletion
		ifFalse: [ OController ]
		ifTrue: [ ECController ])
			model: self'! !

!NOCCompletionTable class methodsFor: 'as yet unclassified' stamp: 'rr 4/17/2009 15:00'!
methodChanged: event
	event isRemoved ifTrue: [^self].
	event isRecategorized ifTrue: [^self].
	self default totalNumberOfEntries < 200 ifTrue: [self default quickFillWithCategoryOf: event itemClass].
	self default totalNumberOfEntries < 500 ifTrue: [self default quickFillWithClass: event itemClass].
	self default justCompiled: event itemSelector in: event itemClass.! !

!NOCCompletionTable methodsFor: 'as yet unclassified' stamp: 'rr 4/9/2009 17:55'!
addEntry: aString 
	| d |
	d := DateAndTime now.
	self 
		addEntry: aString
		date: d! !

!NOCCompletionTable methodsFor: 'as yet unclassified' stamp: 'rr 4/15/2009 10:52'!
addEntry: aString date: d 
	| lists |
	lists := self listsForPrefix: aString.
	lists do: [:e | e
		addEntry: aString
		date: d] ! !

!NOCCompletionTable methodsFor: 'as yet unclassified' stamp: 'rr 5/11/2009 23:10'!
classesInCategory: category
	^ (Smalltalk organization listAtCategoryNamed: category) collect: [:className | Smalltalk at: className]! !

!NOCCompletionTable methodsFor: 'as yet unclassified' stamp: 'ul 11/6/2010 06:35'!
compiled: selector in: class date: date

	| method |
	self addEntry: selector date: date.
	self class classes addEntry: class theNonMetaClass name date: date.
	(class canUnderstand: selector) ifFalse: [ ^self ].
	method := class compiledMethodAt: selector ifAbsent: [ ^self ].
	method messages do: [ :m | self  addEntry: m date: date ].
	method literals do: [ :each |
		(each isVariableBinding and: [
			each key notNil and: [
				each key first isUppercase ] ])
					ifTrue: [ 
						self class classes addEntry: each key date: date ] ]! !

!NOCCompletionTable methodsFor: 'as yet unclassified' stamp: 'rr 4/17/2009 14:14'!
entriesMatching: prefix
	| list |
	
	list := self listForPrefix: prefix.
	^ list entriesMatching: prefix! !

!NOCCompletionTable methodsFor: 'as yet unclassified' stamp: 'rr 4/9/2009 17:42'!
entriesPerPrefix: n
	numberofEntries := n! !

!NOCCompletionTable methodsFor: 'as yet unclassified' stamp: 'rr 4/10/2009 12:11'!
fillRate
	^ self totalNumberOfEntries / self maxNumberOfEntries ! !

!NOCCompletionTable methodsFor: 'initialize-release' stamp: 'rr 4/9/2009 17:45'!
initialize
	table := Dictionary new.! !

!NOCCompletionTable methodsFor: 'as yet unclassified' stamp: 'rr 4/16/2009 12:01'!
justCompiled: selector in: class 
	| date |
	date := DateAndTime now.
	self 
		compiled: selector
		in: class
		date: date! !

!NOCCompletionTable methodsFor: 'as yet unclassified' stamp: 'EstebanLorenzano 4/12/2012 11:20'!
listForPrefix: aString 
	| prefix |
	aString isEmpty ifTrue: [^ NOCEntryList ofSize: numberofEntries].
	prefix := aString size = 1 
			ifTrue: [ aString first asLowercase asString] 
			ifFalse: [(aString first: 2) collect: [:e | e asLowercase]].
			
	^ table 
		at: prefix
		ifAbsentPut: [ NOCEntryList ofSize: numberofEntries ]! !

!NOCCompletionTable methodsFor: 'as yet unclassified' stamp: 'EstebanLorenzano 4/12/2012 11:20'!
listsForPrefix: aString 
	|  prefixes |
	aString isEmpty ifTrue: [^ Array with: (NOCEntryList ofSize: numberofEntries)].
	prefixes := OrderedCollection with: aString first asLowercase asString.
	 
	aString size > 1 
			ifTrue: [prefixes add: ((aString first: 2) collect: [:e | e asLowercase])].
	^ prefixes collect: [:prefix | table 
		at: prefix
		ifAbsentPut: [ NOCEntryList ofSize: numberofEntries ]]! !

!NOCCompletionTable methodsFor: 'as yet unclassified' stamp: 'rr 4/10/2009 12:10'!
maxNumberOfEntries
	^ 26 * 26 * numberofEntries ! !

!NOCCompletionTable methodsFor: 'as yet unclassified' stamp: 'rr 4/9/2009 17:46'!
numberOfEntries
	^ numberofEntries! !

!NOCCompletionTable methodsFor: 'as yet unclassified' stamp: 'rr 5/11/2009 23:11'!
quickFillWithCategoriesMatching: pattern
	(Smalltalk organization categoriesMatching: pattern) do: [:category | 
		(self classesInCategory: category) do: [:e | self quickFillWithClass: e]]! !

!NOCCompletionTable methodsFor: 'as yet unclassified' stamp: 'rr 5/11/2009 23:10'!
quickFillWithCategoryOf: cls
	(self classesInCategory: cls theNonMetaClass category) do: [:e | self quickFillWithClass: e]! !

!NOCCompletionTable methodsFor: 'as yet unclassified' stamp: 'rr 5/28/2009 14:10'!
quickFillWithClass: cls
	cls methodsDo: [:e | self justCompiled: e selector in: cls]
	! !

!NOCCompletionTable methodsFor: 'accessing' stamp: 'rr 4/10/2009 11:21'!
reset
	table := Dictionary new.! !

!NOCCompletionTable methodsFor: 'as yet unclassified' stamp: 'rr 4/9/2009 17:49'!
totalNumberOfEntries
	^ table inject: 0 into: [:total :list | total + list numEntries]! !

Object subclass: #NOCEmptyModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NOCompletion-Model'!

!NOCEmptyModel methodsFor: 'as yet unclassified' stamp: 'rr 4/14/2009 16:47'!
entries
	^ Array new! !

!NOCEmptyModel methodsFor: 'as yet unclassified' stamp: 'rr 4/17/2009 14:27'!
entryCount 
	^ 0! !

!NOCEmptyModel methodsFor: 'as yet unclassified' stamp: 'rr 4/17/2009 14:26'!
narrowString: string! !

!NOCEmptyModel methodsFor: 'as yet unclassified' stamp: 'rr 4/17/2009 14:26'!
narrowWith: string 
! !

Object subclass: #NOCEntryList
	instanceVariableNames: 'size entries entryHead'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NOCompletion-Model'!

!NOCEntryList class methodsFor: 'as yet unclassified' stamp: 'rr 2/21/2009 11:44'!
ofSize: n 
	^ self new setSize: n; yourself! !

!NOCEntryList methodsFor: 'adding' stamp: 'rr 4/9/2009 16:06'!
addEntry: aSymbol
	self addEntry: aSymbol date: DateAndTime now! !

!NOCEntryList methodsFor: 'adding' stamp: 'EstebanLorenzano 4/12/2012 11:21'!
addEntry: aSymbol date: aDate

	| entry currentEntry |
	entry := entries at: aSymbol ifAbsent: nil.
	entry 
		ifNotNil: [ entry unlink ]
		ifNil: [ 
			entry := NOCDatedEntry contents: aSymbol type: #selector.
			entries at: aSymbol put: entry ].
	entry date: aDate.
	currentEntry := entryHead previous.
	[ currentEntry == entryHead or: [
		currentEntry date <= aDate ] ] whileFalse: [
			currentEntry := currentEntry previous ].
	currentEntry link: entry.
	entries size > size ifTrue: [
		entry := entryHead next unlink.
		entries removeKey: entry contents ]! !

!NOCEntryList methodsFor: 'accessing' stamp: 'ul 9/29/2010 18:56'!
entriesMatching: prefix
	
	^Array new: entries size // 4 + 1 streamContents: [ :stream |
		| entry |
		entry := self firstEntry.
		[ entry == entryHead ] whileFalse: [
			(entry matches: prefix) ifTrue: [ stream nextPut: entry ].
			entry := entry previous ] ]! !

!NOCEntryList methodsFor: 'accessing' stamp: 'rr 4/9/2009 16:14'!
first
	^self firstEntry contents! !

!NOCEntryList methodsFor: 'accessing' stamp: 'ul 9/27/2010 05:31'!
firstEntry
	^ entryHead previous! !

!NOCEntryList methodsFor: 'accessing' stamp: 'rr 4/9/2009 16:14'!
last
	^self lastEntry contents! !

!NOCEntryList methodsFor: 'accessing' stamp: 'ul 9/27/2010 05:31'!
lastEntry
	^ entryHead next! !

!NOCEntryList methodsFor: 'accessing' stamp: 'rr 2/21/2009 11:46'!
numEntries
	^ entries size! !

!NOCEntryList methodsFor: 'as yet unclassified' stamp: 'EstebanLorenzano 4/12/2012 11:21'!
setSize: n
	size := n.
	entries := Dictionary new: n.
	entryHead := NOCDatedEntry contents: #'' size type: #selector.
	entryHead
		next: entryHead;
		previous: entryHead.
	
	! !

Object subclass: #NOCRecentChanges
	instanceVariableNames: 'records'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NOCompletion-Model'!

!NOCRecentChanges methodsFor: 'as yet unclassified' stamp: 'EstebanLorenzano 4/12/2012 11:17'!
fillCompletionTable
	records do: [:e | self fillCompletionTable: NOCCompletionTable default withRecord: e]! !

!NOCRecentChanges methodsFor: 'as yet unclassified' stamp: 'rr 4/16/2009 12:05'!
fillCompletionTable: table withRecord: r
	r methodClass ifNotNilDo: [:cls |
		table compiled: r methodSelector in: cls date: r timeStamp]! !

!NOCRecentChanges methodsFor: 'as yet unclassified' stamp: 'ul 10/29/2010 01:57'!
readRecentChanges
	| changeFile end changeList |
	changeFile := (SourceFiles at: 2) readOnlyCopy setConverterForCode.
	end := changeFile size.
	changeList := Cursor read showWhile: [
		ChangeList new
			scanFile: changeFile
			from: (0 max: end - 50000)
			to: end ].
	records := changeList changeList select: [:e | e type = #method].
	! !
NOCCompletionTable initialize!
NOCController initialize!
